close all
clear all
clc

delete *.out

homeDir = pwd;
ExeDir   = 'C:\Users\Joel\LY_Laptop\Learning_Opensees\SensitivityManual\2013-06-28_SensitivityCheck';
ExcutableTool = 'openSees_Yong.exe';
sourceFileDir = pwd;

exampleNameList = {
    'Example1_Soil2D.tcl'              
    'Example1_Soil2D_FFD.tcl'
};

for i = 1:length(exampleNameList)
    disp(['Yong: Now it is running example: ' exampleNameList{i}])
    sourceFileName = exampleNameList{i};
    % Call OpenSees to Run the job. 
    system([ExeDir filesep ExcutableTool ' ' sourceFileDir filesep sourceFileName]);
    disp(['Yong: Now it is finishing example: ' exampleNameList{i}])
end;

load ddm29G1.out
load disp29.out
load disp29G1.out
load disp29G2.out
load disp29G3.out
load disp29G4.out
plot(ddm29G1(:,1)-1,ddm29G1(:,2),'b')
hold on
plot(disp29(:,1)-1,(disp29G1(:,2)-disp29(:,2))/(0.01*54450),'m')
plot(disp29(:,1)-1,(disp29G2(:,2)-disp29(:,2))/(0.001*54450),'g')
plot(disp29(:,1)-1,(disp29G3(:,2)-disp29(:,2))/(0.0001*54450),'k')
plot(disp29(:,1)-1,(disp29G4(:,2)-disp29(:,2))/(0.00001*54450),'r:')
legend('DDM','FFD 0.01','FFD 0.001','FFD 0.0001','FFD 0.00001')
saveas(gcf,'Example1_CheckedByYong','fig')
